VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DBMouse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private MouseOn As Boolean
Private MouseUp As Boolean
Private MouseDown As Boolean
Private MouseLeft As Boolean
Private MouseRight As Boolean
Private mLeftDown As Boolean
Private mLeftAuto As Boolean
Private mLeftPressed As Boolean
Private mRightDown As Boolean
Private mRightAuto As Boolean
Private mRightPressed As Boolean
Private LRepeat As Integer
Private RRepeat As Integer
Private LRInc As Integer
Private RRInc As Integer
Private MouseRect As RECT
Private MouseSpeed As Integer
Private MouseSprite As Integer
Private MouseGrid As Integer
Private XRate As Integer
Private YRate As Integer

'Subs for MouseInput
Public Sub InitializeMouse(hwnd&, Optional Buffer& = 10)
    On Error GoTo NotInitialized
    
'Initialize directinput
    Set DirectInput = DirectX.DirectInputCreate
    Set mDirectInputDevice = DirectInput.CreateDevice("guid_SysMouse")
    Call mDirectInputDevice.SetCommonDataFormat(DIFORMAT_MOUSE)
    Call mDirectInputDevice.SetCooperativeLevel(hwnd, DISCL_FOREGROUND Or DISCL_EXCLUSIVE)
    
    'Redim DevData
    ReDim mDevData(1 To Buffer) As DIDEVICEOBJECTDATA
    
    'Set up DiProp
    mDevProp.lHow = DIPH_DEVICE
    mDevProp.lObj = 0
    mDevProp.lData = Buffer
    Call mDirectInputDevice.SetProperty("DIPROP_BUFFERSIZE", mDevProp)
    
    'set mouse on
    MouseOn = True
    mLeftAuto = True
    mRightAuto = True
    
    'default for mouse
    MouseX = 0
    MouseY = 0
    MouseSpeed = 1
    With MouseRect
        .Left = 0
        .Top = 0
        .Right = 320
        .Bottom = 240
    End With
    MouseGrid = 1
    
    'Aquire Mouse
    mDirectInputDevice.Acquire
    
    DaBoodaMouseOn = True
    Exit Sub
    
NotInitialized:
    DaBoodaMouseOn = False
    
End Sub

Public Sub PollMouse()
    Dim Index As Integer
    mEvents = mDirectInputDevice.GetDeviceData(mDevData, DIGDD_DEFAULT)
    
MouseLeft = False
MouseUp = False
MouseRight = False
MouseDown = False
If mLeftAuto = False And mLeftDown = True And mLeftPressed = True Then
    mLeftDown = False
End If
If mRightAuto = False And mRightDown = True And mRightPressed = True Then
    mRightDown = False
End If
XRate = 0
YRate = 0

    For Index = 1 To mEvents
        Select Case mDevData(Index).lOfs
            Case DIMOFS_X
                If mDevData(Index).lData < 0 Then MouseLeft = True
                If mDevData(Index).lData > 0 Then MouseRight = True
                MouseX = MouseX + (MouseSpeed * mDevData(Index).lData)
                XRate = mDevData(Index).lData
            Case DIMOFS_Y
                If mDevData(Index).lData < 0 Then MouseUp = True
                If mDevData(Index).lData > 0 Then MouseDown = True
                MouseY = MouseY + (MouseSpeed * mDevData(Index).lData)
                YRate = mDevData(Index).lData
            Case DIMOFS_BUTTON0
            If mLeftAuto = True Then
                If mDevData(Index).lData = 128 Then
                    mLeftDown = True
                    mLeftPressed = True
                End If
                If mDevData(Index).lData = 0 Then
                    mLeftDown = False
                    mLeftPressed = False
                End If
            Else:
                If mDevData(Index).lData = 128 And mLeftAuto = False And mLeftPressed = False Then
                    mLeftDown = True
                    mLeftPressed = True
                End If
                If mDevData(Index).lData = 0 And mLeftAuto = False And mLeftPressed = True Then
                    mLeftDown = False
                    mLeftPressed = False
                End If
            End If
             Case DIMOFS_BUTTON1
             If mRightAuto = True Then
                If mDevData(Index).lData = 128 Then
                    mRightDown = True
                    mRightPressed = True
                End If
                If mDevData(Index).lData = 0 Then
                    mRightDown = False
                    mRightPressed = False
                End If
            Else:
                If mDevData(Index).lData = 128 And mRightPressed = False Then
                    mRightDown = True
                    mRightPressed = True
                End If
                If mDevData(Index).lData = 0 And mRightPressed = True Then
                    mRightDown = False
                    mRightPressed = False
                End If
            End If
        End Select
        
    Next Index
    
If mLeftAuto = True Then
    If mLeftPressed = False Then LRInc = LRepeat
    If mLeftPressed = True And LRInc < LRepeat Then mLeftDown = False
    If mLeftPressed = True And LRInc >= LRepeat Then
        mLeftDown = True
        LRInc = 1
    End If
    If mLeftPressed = True And mLeftDown = False Then LRInc = LRInc + 1
End If
If mRightAuto = True Then
    If mRightPressed = False Then RRInc = RRepeat
    If mRightPressed = True And RRInc < RRepeat Then mRightDown = False
    If mRightPressed = True And RRInc >= RRepeat Then
        mRightDown = True
        RRInc = 1
    End If
    If mRightPressed = True And mRightDown = False Then RRInc = RRInc + 1
End If
'update the mousex and y to coordinate with the viewrect for mouse
With MouseRect
    If MouseX < .Left Then MouseX = .Left
    If MouseX > .Right Then MouseX = .Right
    If MouseY < .Top Then MouseY = .Top
    If MouseY > .Bottom Then MouseY = .Bottom
End With

'update the sprite if needed
If MouseSprite <> 0 Then
    Sprite(MouseSprite).XPos = MouseX
    Sprite(MouseSprite).YPos = MouseY
End If

NoUpdate:       'focus was lost

End Sub

Public Sub SetLeftAutoFire(Value As Boolean)
    mLeftAuto = Value
End Sub

Public Sub SetRightAutoFire(Value As Boolean)
    mRightAuto = Value
End Sub

Public Function GetMouseLeft() As Boolean
    GetMouseLeft = MouseLeft
End Function

Public Function GetMouseUp() As Boolean
    GetMouseUp = MouseUp
End Function

Public Function GetMouseRight() As Boolean
    GetMouseRight = MouseRight
End Function

Public Function GetMouseDown() As Boolean
    GetMouseDown = MouseDown
End Function

Public Function GetLeftButton() As Boolean
    GetLeftButton = mLeftDown
End Function

Public Function GetRightButton() As Boolean
    GetRightButton = mRightDown
End Function

Public Sub SetLeftRepeat(Value As Integer)
    LRepeat = Value
    LRInc = LRepeat
End Sub
Public Sub SetRightRepeat(Value As Integer)
    RRepeat = Value
    RRInc = RRepeat
End Sub

Public Function GetLeftRepeat() As Integer
    GetLeftRepeat = LRInc
End Function
Public Function GetRightRepeat() As Integer
    GetRightRepeat = RRInc
End Function

'Added V1.4 mouse options for movement and view
Public Sub SetUpMouseViewRect(Left As Integer, Top As Integer, Right As Integer, Bottom As Integer)
    With MouseRect
        .Left = Left
        .Top = Top
        .Right = Right
        .Bottom = Bottom
    End With
End Sub

Public Sub SetMouseX(XValue As Integer)
    MouseX = XValue
End Sub

Public Sub SetMouseY(YValue As Integer)
    MouseY = YValue
End Sub

Public Sub SetMousePosition(XValue As Integer, YValue As Integer)
    MouseX = XValue
    MouseY = YValue
End Sub

Public Sub SetMouseSpeed(Value As Integer)
    MouseSpeed = Value
End Sub

Public Function GetX() As Integer
    GetX = MouseX
End Function

Public Function GetY() As Integer
    GetY = MouseY
End Function

Public Sub SetGridSize(GridSize As Integer)
    If GridSize = 0 Then GridSize = 1
    MouseGrid = GridSize
End Sub
Public Function GetGridSize() As Integer
    GetGridSize = MouseGrid
End Function

Public Function GetGridX() As Integer
GetGridX = Int(MouseX / MouseGrid) * MouseGrid
End Function
Public Function GetGridY() As Integer
GetGridY = Int(MouseY / MouseGrid) * MouseGrid
End Function

Public Function GetRateX(Optional Absolute As Boolean) As Integer
If Absolute = True Then
    GetRateX = Abs(XRate)
Else:
    GetRateX = XRate
End If
End Function
Public Function GetRateY(Optional Absolute As Boolean) As Integer
If Absolute = True Then
    GetRateY = Abs(YRate)
Else:
    GetRateY = YRate
End If
End Function

Public Sub AttachSpriteToCursor(Index As Integer)
    MouseSprite = Index
End Sub

