VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DBResource"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'This is the DaBooda Turbo 2D Engine Resource Class
'Added into v1.4
'Main code provided by Lucky at http://www.rookscape.com/vbgaming/
'Coded into Class by Andrew "DaBooda" Stickney
'Encoding provided by Alan ____

'This structure will describe our binary file's
'size and number of contained files
Private Type FILEHEADER
    intNumFiles As Integer      'How many files are inside?
    lngFileSize As Long         'How big is this file? (Used to check integrity)
End Type

'This structure will describe each file contained
'in our binary file
Private Type INFOHEADER
    lngFileSize As Long         'How big is this chunk of stored data?
    lngFileStart As Long        'Where does the chunk start?
    strFileName As String * 16  'What's the name of the file this data came from?
End Type

'These Variables are for the class
'Variables for files, to store values until Combine is called
Private NumFiles As Integer
Private FileSize() As Long
Private FileName() As String * 16
Private FileData() As Byte
Private FileLength As Long

'These are main Structures
Private FileHead As FILEHEADER
Private InfoHead() As INFOHEADER

'THese are for free file commands
Private DataFile As Integer
Private BinaryFile As Integer

'These are for just this class
Private FileFolder As String
Private PassWord(15) As Byte     'I figure 16 will be big enough

'This Command initializes the variables on loading of class
Private Sub Class_Initialize()
NumFiles = 0
ReDim FileSize(0) As Long
ReDim FileName(0) As String * 16
ReDim FileData(0) As Byte
ReDim InfoHead(0) As INFOHEADER
End Sub

'This first set of commands simply allow you to set up the different folders
Public Sub SetFolderPath(Path As String)
    FileFolder = Path
End Sub
Public Function GetFolderPath() As String
    GetFolderPath = FileFolder
End Function

'This command is for the password, right now I am just allowing the user to put it in
'It will be used for combine and extract
Public Sub EnterPassword(Pass As String)
    'Check for length
    If Len(Pass) > 16 Then
        MsgBox "Password can only be 16 characters in length!", vbOKOnly, "Error"
        Exit Sub
    End If
    'Right now I am just entering it into the byte array
    Dim i As Integer
    For i = 1 To Len(Pass)
        PassWord(i - 1) = Asc(Mid$(Pass, i, 1))
    Next i
    
End Sub

'This command actually adds the files to the class, these are the files to combine
'when the combine command is called, basically this checks for validaty of file,
'gets the size and name of it too
Public Sub AddFile(Name As String)
    'first check to see if string is 16
    If Len(Name) > 16 Then
        MsgBox "File Name can only be 16 characters in length!", vbOKOnly, "Error"
        Exit Sub
    End If
    
    'on error goto message
    On Err GoTo NoFile
    
    'redim arrays
    ReDim Preserve FileSize(NumFiles) As Long
    ReDim Preserve FileName(NumFiles) As String * 16
    
    'Now find a free file
    DataFile = FreeFile
    'now open it
    Open FileFolder & Name For Binary Access Read Lock Write As DataFile
    'Set the New Size
    ReDim FileData(LOF(DataFile) - 1) As Byte
    'Get the data
    Get DataFile, 1, FileData
    'close the file
    Close DataFile
    'Fill the variable with the size and Name these will be used for the combine
    'to determine length of file\
    FileSize(NumFiles) = (UBound(FileData) + 1)
    FileName(NumFiles) = Name
    
    'Advance number of files
    NumFiles = NumFiles + 1
    
    'this command also gives the class the names of the files to use later in combine
    'and the kill command
    
'exit the sub
    Exit Sub
    
NoFile:     'Display message if there was an error
    MsgBox "Not a valid File!", vbOKOnly, "Error"
End Sub

'This command removes a file from the resource file
Public Sub RemoveFile(Number As Integer)
Number = Number - 1
    If Number < 0 Or Number > NumFiles - 1 Then
        MsgBox "Not a valid file number", vbOKOnly, "Error"
        Exit Sub
    End If

Dim i As Integer
If Number <> NumFiles - 1 Then
For i = Number To NumFiles - 2
    FileName(i) = FileName(i + 1)
    FileSize(i) = FileSize(i + 1)
Next i
    NumFiles = NumFiles - 1
Else:
    NumFiles = NumFiles - 1
End If

End Sub

'This command combines the whole resource file
Public Sub CombineResourceFile(Name As String)
    'subtract one from numfiles
    NumFiles = NumFiles - 1

    'variable for loop
    Dim i As Integer
    
    'on error exit to message
    On Err GoTo NoCombine
    
    'im going to be insertinb encoded values into
    'the sizes and start points... I will not encode the
    'num of files in the file head, just because it is and integer
    'and even if the hacker has that, they will not be able to do
    'anything without the file sizes or start points...
    'Set up the file header
    FileHead.intNumFiles = NumFiles + 1
    'set up initial size including password
    FileLength = (6) + (FileHead.intNumFiles * 24)
    'loop through all and add sizes
    For i = 0 To NumFiles
        FileLength = FileLength + FileSize(i)
    Next i
    'set into fileheader
    FileHead.lngFileSize = Encode(FileLength)
    
    'set up InfoHeaders
    ReDim InfoHead(NumFiles) As INFOHEADER
    'initial start
    FileLength = (6) + (FileHead.intNumFiles * 24) + 1
    'loop
    For i = 0 To NumFiles
    'set size
    InfoHead(i).lngFileSize = Encode(FileSize(i))
    'set up position
    InfoHead(i).lngFileStart = Encode(FileLength)
    'increment for next start
    FileLength = FileLength + FileSize(i)
    'set the name
    InfoHead(i).strFileName = FileName(i)
    'loop
    Next i
    
    'open the new file
    BinaryFile = FreeFile
    Open FileFolder & Name For Binary Access Write Lock Write As BinaryFile

    'put the file info and header to file
    Put BinaryFile, 1, FileHead
    Put BinaryFile, , InfoHead
    'loop through all data files load them in and put to file
    For i = 0 To NumFiles
    'Now find a free file
    DataFile = FreeFile
    'now open it
    Open FileFolder & FileName(i) For Binary Access Read Lock Write As DataFile
    'Set the New Size
    ReDim FileData(LOF(DataFile) - 1) As Byte
    'Get the data
    Get DataFile, 1, FileData
    'close the file
    Close DataFile
    'now put data to file
    Put BinaryFile, , FileData
    Next i
    
    'close the file
    Close BinaryFile
    
    'add one to numfiles
    NumFiles = NumFiles + 1
    
    'exit sub before error handle
    Exit Sub
    
'Exit sub
Exit Sub

NoCombine:
    MsgBox "There was an error while combining file!", vbOKOnly, "Error"
End Sub

'This next command extracts the data from a resource file and checks the password,
'if the password is incorrect the files will be automatically killed and access will
'be denied...the password used will be the one added with the enter password command
Public Sub ExtractFromResourceFile(Name As String)
    
    'reset the arrays
    NumFiles = 0
    ReDim FileSize(0) As Long
    ReDim FileName(0) As String * 16
    
    'error handler first
    On Err GoTo NoExtract
    
    'Open the binary file
    BinaryFile = FreeFile
    Open FileFolder & Name For Binary Access Read Lock Write As BinaryFile
    
    'Extract the FILEHEADER
    Get BinaryFile, 1, FileHead
    NumFiles = FileHead.intNumFiles - 1
        'set up the variables again
        ReDim Preserve FileSize(NumFiles) As Long
        ReDim Preserve FileName(NumFiles) As String * 16
    
    'lets first decode the filesize and check for validity
    'this not only checks the pass, but checks for corruption... i.e. hacking
    FileHead.lngFileSize = Decode(FileHead.lngFileSize)
    
    'Check the file for validity
    If LOF(BinaryFile) <> FileHead.lngFileSize Then GoTo InValidPass
    
    'Size the InfoHead array
    ReDim InfoHead(FileHead.intNumFiles - 1) As INFOHEADER
    
    'Extract the INFOHEADER
    Get BinaryFile, , InfoHead
    
    'Extract all of the files from the binary file
    For i = 0 To UBound(InfoHead)
        'decode the values first
        InfoHead(i).lngFileSize = Decode(InfoHead(i).lngFileSize)
        InfoHead(i).lngFileStart = Decode(InfoHead(i).lngFileStart)
        
        'Resize the byte data array
        ReDim FileData(InfoHead(i).lngFileSize - 1) As Byte
        'Get the data
        Get BinaryFile, InfoHead(i).lngFileStart, FileData
        'Open a new file and store the data
        DataFile = FreeFile
        Open FileFolder & InfoHead(i).strFileName For Binary Access Write Lock Write As DataFile
        Put DataFile, 1, FileData
        Close DataFile
        FileSize(i) = InfoHead(i).lngFileSize
        FileName(i) = InfoHead(i).strFileName
    Next
    
    'Close the binary file
    Close BinaryFile
    
    'add one to numfiles
    NumFiles = NumFiles + 1
    
    'Exit before we hit the error handler
    Exit Sub


NoExtract:
    MsgBox "The file does not exist!", vbOKOnly, "Invalid File"
    Exit Sub
    
'this is for the invalid password, it will kill(delete) delete all the files and
'exit sub, not allowing access to them
InValidPass:
    'display message
    MsgBox "Permission not granted! Or File has been corrupted!", vbOKOnly, "Permission Denied!"
    
End Sub

'This next command just simply returns the current file count,
'note it is only accurate after the combine or extract command
Public Function GetFileCount() As Integer
    GetFileCount = NumFiles
End Function

'this command kills(Deletes) all the current files, can be used at any time
'as long as there are files to kill, it will not error
'Also this will reset data and numfiles to 0
Public Sub KillFiles()
    'error catch
    On Err GoTo NoKill
    
    'dim variable for loop
    Dim i As Integer
    
    'loop through and kill all the files
    For i = 0 To NumFiles - 1
        Kill FileFolder & FileName(i)
    Next i
    
    'destroy data
    NumFiles = 0
    ReDim FileName(0) As String * 16
    ReDim FileSize(0) As Long
    
    'exit
    Exit Sub
    
NoKill:
    MsgBox "There was an error during the kill process!", vbOKOnly, "Error"
End Sub

'this command clears the data, not the same as kill, this will keep the files
Public Sub Clear()
    'destroy data
    NumFiles = 0
    ReDim FileName(0) As String * 16
    ReDim FileSize(0) As Long
End Sub

'This Command returns the file name of a certain file
Public Function GetFileName(Number As Integer) As String
    GetFileName = FileName(Number - 1)
End Function
'This command returns the size of a file
Public Function GetFileSize(Number As Integer, Optional Format As Integer) As Long
    If Format < 1 Then Format = 1
    If Format > 3 Then Format = 3
Select Case Format
    Case 1
    GetFileSize = FileSize(Number - 1)
    
    Case 2
    GetFileSize = FileSize(Number - 1) / 1000
    
    Case 3
    GetFileSize = FileSize(Number - 1) / 1000000
End Select

End Function
'This command returns the total size of the resource file
Public Function GetResourceSize(Optional Format As Integer) As Long
If Format < 1 Then Format = 1
If Format > 3 Then Format = 3
Dim Total As Long
Dim i As Integer
For i = 0 To NumFiles - 1
    Total = Total + FileSize(i)
Next i
Select Case Format
    Case 1
    GetResourceSize = Total
    
    Case 2
    GetResourceSize = Total / 1000
    
    Case 3
    GetResourceSize = Total / 1000000
End Select

End Function

'This command actually creates a junk file,
'Which is nothing but a collection of random bytes.
'The purpose is to throw this at the end of your resource file to deter
'hackers from back seeking for validity.
Public Sub CreateJunkFile(Name As String, Length As Integer)
'check length for good size
If Length < 2 Then Length = 2

'redim file data to length
ReDim FileData(Length - 1) As Byte

'fill filedata with random bytes
Randomize Timer
Dim T As Integer
For T = 0 To Length - 1
    FileData(T) = Int(Rnd * 256)
Next T

'Now get a free file
DataFile = FreeFile

'now open the junk file to write
Open FileFolder & Name For Binary Access Write Lock Write As DataFile

'put the data to file
Put DataFile, 1, FileData

'close the file
Close DataFile

End Sub

'This sub takes the value and encodes the password into it, basically doing a seesaw
'effect that will be hard to break
Private Function Encode(Value As Long) As Long
Dim PLoop As Integer        'this is the character loop
Dim CPass As Integer        'this is the current pass character
Dim Combine As Long      'this is the combo of the pass and data
Dim Direction As Integer    'the direction of shifting
Combine = Value
Direction = 1

For PLoop = 0 To 15
    CPass = PassWord(PLoop)
    Combine = Combine + (CPass * Direction)
    If Direction = 1 Then
        Direction = -1
    Else:
        Direction = 1
    End If
    
Next PLoop

Encode = Combine
End Function

'decode does the same as encode, just backwards... it starts with subtracting the value
Private Function Decode(Value As Long) As Long
Dim PLoop As Integer        'this is the character loop
Dim CPass As Integer        'this is the current pass character
Dim Combine As Long      'this is the combo of the pass and data
Dim Direction As Integer    'the direction of shifting

Combine = Value
Direction = -1

For PLoop = 0 To 15
    CPass = PassWord(PLoop)
    Combine = Combine + (CPass * Direction)
    If Direction = 1 Then
        Direction = -1
    Else:
        Direction = 1
    End If
    
Next PLoop

Decode = Combine
End Function

