VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DBText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Sub CreateFont(Name As String, Size As Single, Optional Bold As Boolean, Optional Italic As Boolean, Optional Underline As Boolean, Optional StrikeThru As Boolean)
    On Error GoTo NotInitialized
    
    With StandardFont(1)
        .Name = Name
        .Size = Size
        .Bold = Bold
        .Italic = Italic
        .Underline = Underline
        .Strikethrough = StrikeThru
    End With
    
    Set ScreenFontDesc(1) = StandardFont(1)
    Set ScreenFont(1) = D3DX.CreateFont(Direct3DDevice, ScreenFontDesc(1).hFont)
    
   DaBoodaFontOn = True
Exit Sub
NotInitialized:
    DaBoodaFontOn = False
End Sub

Public Sub CreateFontMultiple(Index As Integer, Name As String, Size As Single, Optional Bold As Boolean, Optional Italic As Boolean, Optional Underline As Boolean, Optional StrikeThru As Boolean)
    On Error GoTo NotInitialized
    
    With StandardFont(Index)
        .Name = Name
        .Size = Size
        .Bold = Bold
        .Italic = Italic
        .Underline = Underline
        .Strikethrough = StrikeThru
    End With
    
    Set ScreenFontDesc(Index) = StandardFont(Index)
    Set ScreenFont(Index) = D3DX.CreateFont(Direct3DDevice, ScreenFontDesc(Index).hFont)
    'set to say font is set
    FontSet(Index) = True
    
   DaBoodaFontOn = True
Exit Sub
NotInitialized:
    DaBoodaFontOn = False
End Sub

Public Sub Add()
    TextCount = TextCount + 1
    ReDim Preserve TextEX(TextCount) As TextInfo
    With TextEX(TextCount)
        .Color.Alpha = 255
        .Color.Red = 255
        .Color.Green = 255
        .Color.Blue = 255
        .fText = ""
        .Visible = True
        .ZOrder = 0
        .XPos = 0
        .YPos = 0
        .Width = 30
        .Height = 20
        .FIndex = 1
    End With
    
End Sub

Public Sub AddFromSource(SourceIndex As Integer)
    TextCount = TextCount + 1
    ReDim Preserve TextEX(TextCount) As TextInfo
    
    TextEX(TextCount) = TextEX(SourceIndex)
End Sub

Public Sub Copy(FromIndex As Integer, ToIndex As Integer)
    TextEX(ToIndex) = TextEX(FromIndex)
End Sub

Public Sub Swap(FromIndex As Integer, ToIndex As Integer)
    TextEX(0) = TextEX(FromIndex)
    TextEX(FromIndex) = TextEX(ToIndex)
    TextEX(ToIndex) = TextEX(0)
End Sub

Public Sub Clear()
    TextCount = 0
    ReDim TextEX(0) As TextInfo
End Sub

Public Sub SetAlpha(Index As Integer, Value As Integer)
    TextEX(Index).Color.Alpha = Value
End Sub
Public Sub SetRed(Index As Integer, Value As Integer)
    TextEX(Index).Color.Red = Value
End Sub
Public Sub SetGreen(Index As Integer, Value As Integer)
    TextEX(Index).Color.Green = Value
End Sub
Public Sub SetBlue(Index As Integer, Value As Integer)
    TextEX(Index).Color.Blue = Value
End Sub

Public Sub SetText(Index As Integer, Value As String)
    TextEX(Index).fText = Value
End Sub
Public Sub SetZOrder(Index As Integer, Value As Integer)
    TextEX(Index).ZOrder = Value
End Sub
Public Sub SetVisible(Index As Integer, Value As Boolean)
    TextEX(Index).Visible = Value
End Sub

Public Sub SetXPosition(Index As Integer, Value As Single)
    TextEX(Index).XPos = Value
End Sub
Public Sub SetYPosition(Index As Integer, Value As Single)
    TextEX(Index).YPos = Value
End Sub
Public Sub SetWidth(Index As Integer, Value As Single)
    TextEX(Index).Width = Value
End Sub
Public Sub SetHeight(Index As Integer, Value As Single)
    TextEX(Index).Height = Value
End Sub

Public Sub SetFontIndex(Index As Integer, Value As Integer)
    If Value < 1 Or Value > 16 Then Value = 1
    TextEX(Index).FIndex = Value
End Sub

Public Function GetAlpha(Index As Integer) As Integer
    GetAlpha = TextEX(Index).Color.Alpha
End Function
Public Function GetRed(Index As Integer) As Integer
    GetRed = TextEX(Index).Color.Red
End Function
Public Function GetGreen(Index As Integer) As Integer
    GetGreen = TextEX(Index).Color.Green
End Function
Public Function GetBlue(Index As Integer) As Integer
    GetBlue = TextEX(Index).Color.Blue
End Function

Public Function GetText(Index As Integer) As String
    GetText = TextEX(Index).fText
End Function
Public Function GetZOrder(Index As Integer) As Integer
    GetZOrder = TextEX(Index).ZOrder
End Function
Public Function GetVisible(Index As Integer) As Boolean
    GetVisible = TextEX(Index).Visible
End Function

Public Function GetXPosition(Index As Integer) As Single
    GetXPosition = TextEX(Index).XPos
End Function
Public Function GetYPosition(Index As Integer) As Single
    GetYPosition = TextEX(Index).YPos
End Function
Public Function GetWidth(Index As Integer) As Single
    GetWidth = TextEX(Index).Width
End Function
Public Function GetHeight(Index As Integer) As Single
    GetHeight = TextEX(Index).Height
End Function

Public Function GetFontIndex(Index As Integer) As Integer
    GetFontIndex = TextEX(Index).FIndex
End Function

Public Sub SetIdString(Index As Integer, Value As String)
    TextEX(Index).IdString = Value
End Sub
Public Function GetIdString(Index As Integer) As String
    GetIdString = TextEX(Index).IdString
End Function

Public Sub SetIdNum(Index As Integer, Value As Integer)
    TextEX(Index).IdNum = Value
End Sub
Public Function GetIdNum(Index As Integer) As Integer
    GetIdNum = TextEX(Index).IdNum
End Function

Public Sub SetState(Index As Integer, Value As Integer)
    TextEX(Index).State = Value
End Sub
Public Function GetState(Index As Integer) As Integer
    GetState = TextEX(Index).State
End Function

Public Sub QMSetColor(Index As Integer, Alpha As Integer, Red As Integer, Green As Integer, Blue As Integer)
    With TextEX(Index)
        .Color.Alpha = Alpha
        .Color.Red = Red
        .Color.Green = Green
        .Color.Blue = Blue
    End With
End Sub

Public Sub QMSetPutRectangle(Index As Integer, X As Single, Y As Single, Width As Single, Height As Single)
    With TextEX(Index)
        .XPos = X
        .YPos = Y
        .Width = Width
        .Height = Height
    End With
End Sub

Public Sub QMSetTextView(Left As Integer, Top As Integer, Width As Integer, Height As Integer)
    TextViewLeft = Left
    TextViewTop = Top
    TextViewRight = Left + Width
    TextViewBottom = Top + Height
    TextViewWidth = Width
    TextviewHeight = Height
End Sub

Public Sub QMCenterTextX(Index As Integer)
    Dim tVal As Single
    tVal = TextEX(Index).Width - TextEX(Index).XPos
    tVal = (TextViewWidth - tVal) / 2
    TextEX(Index).XPos = tVal
End Sub

Public Sub QMCenterTextY(Index As Integer)
    Dim tVal As Single
    tVal = TextEX(Index).Height - TextEX(Index).YPos
    tVal = (TextviewHeight - tVal) / 2
    TextEX(Index).YPos = tVal
End Sub

Public Sub QMAlignLeft(Index As Integer)
    TextEX(Index).XPos = 0
End Sub

Public Sub QMAlignRight(Index As Integer)
    TextEX(Index).XPos = TextViewWidth - TextEX(Index).Width
End Sub

Public Sub QMAlignTop(Index As Integer)
    TextEX(Index).YPos = 0
End Sub

Public Sub QMAlignBottom(Index As Integer)
    TextEX(Index).YPos = TextviewHeight - TextEX(Index).Height
End Sub

Public Sub QMSpreadVertical(FromIndex As Integer, ToIndex As Integer, Optional Buffer As Single)
Dim TotalHeight As Single
Dim TotalCount As Integer
Dim SpaceSize As Single
Dim StartY As Single
Dim CLoop As Integer
Dim TopY As Single
Dim BottomY As Single
'set top one first
TextEX(FromIndex).YPos = Buffer
TopY = TextEX(FromIndex).YPos
'set bottom one next
TextEX(ToIndex).YPos = TextviewHeight - Buffer - TextEX(ToIndex).Height
BottomY = TextEX(ToIndex).YPos

'exit sub if count < 3
If (ToIndex - FromIndex) < 3 Then Exit Sub

'get totalheight
TotalHeight = BottomY - TopY

'get totalcount
TotalCount = ToIndex - FromIndex

'get spacesize
SpaceSize = TotalHeight / TotalCount
StartY = SpaceSize
'loop throgh and set
For CLoop = (FromIndex + 1) To (ToIndex - 1)
    TextEX(CLoop).YPos = TopY + StartY
    StartY = StartY + SpaceSize
Next CLoop

End Sub

Public Sub QMSpreadHorizontal(FromIndex As Integer, ToIndex As Integer, Optional Buffer As Single)
Dim TotalWidth As Single
Dim TotalCount As Integer
Dim SpaceSize As Single
Dim StartX As Single
Dim CLoop As Integer
Dim LeftX As Single
Dim RightX As Single
'set top one first
TextEX(FromIndex).XPos = Buffer
LeftX = TextEX(FromIndex).XPos
'set bottom one next
TextEX(ToIndex).XPos = TextViewWidth - Buffer - TextEX(ToIndex).Width
RightX = TextEX(ToIndex).XPos

'exit sub if count < 3
If (ToIndex - FromIndex) < 3 Then Exit Sub

'get totalheight
TotalWidth = RightX - LeftX

'get totalcount
TotalCount = ToIndex - FromIndex

'get spacesize
SpaceSize = TotalWidth / TotalCount
StartX = SpaceSize
'loop throgh and set
For CLoop = (FromIndex + 1) To (ToIndex - 1)
    TextEX(CLoop).XPos = LeftX + StartX
    StartX = StartX + SpaceSize
Next CLoop

End Sub

Public Sub QMCenterVertical(FromIndex As Integer, ToIndex As Integer, Optional Buffer As Single, Optional Size As Single)
Dim TotalHeight As Single
Dim TotalCount As Integer
Dim StartY As Single
Dim CLoop As Integer

'find total height
For CLoop = FromIndex To ToIndex
    If Size = 0 Then
    TotalHeight = TotalHeight + TextEX(CLoop).Height
    Else:
    TotalHeight = TotalHeight + Size
    End If
    If CLoop <> ToIndex Then TotalHeight = TotalHeight + Buffer
Next CLoop

'find the start point
StartY = (TextviewHeight - TotalHeight) / 2

'loop through and set up
For CLoop = FromIndex To ToIndex
    TextEX(CLoop).YPos = StartY
    If Size = 0 Then
    StartY = StartY + Buffer + TextEX(CLoop).Height
    Else:
    StartY = StartY + Buffer + Size
    End If
Next CLoop

End Sub

Public Sub QMCenterHorizontal(FromIndex As Integer, ToIndex As Integer, Optional Buffer As Single, Optional Size As Single)
Dim TotalWidth As Single
Dim TotalCount As Integer
Dim StartX As Single
Dim CLoop As Integer

'find total height
For CLoop = FromIndex To ToIndex
    If Size = 0 Then
    TotalWidth = TotalWidth + TextEX(CLoop).Width
    Else:
    TotalWidth = TotalWidth + Size
    End If
    If CLoop <> ToIndex Then TotalWidth = TotalWidth + Buffer
Next CLoop

'find the start point
StartX = (TextViewWidth - TotalWidth) / 2

'loop through and set up
For CLoop = FromIndex To ToIndex
    TextEX(CLoop).XPos = StartX
    If Size = 0 Then
    StartX = StartX + Buffer + TextEX(CLoop).Width
    Else:
    StartX = StartX + Buffer + Size
    End If
Next CLoop

End Sub

Public Sub QMSetRefPosition(Index As Integer, X As Integer, Y As Integer, XRef As Integer, YRef As Integer)
If XRef = 0 Then XRef = 1
If YRef = 0 Then YRef = 1
TextEX(Index).XPos = Int(TextViewWidth / XRef) * X
TextEX(Index).YPos = Int(TextviewHeight / YRef) * Y
End Sub

Public Function GetTextCount() As Integer
    GetTextCount = TextCount
End Function

Public Sub QMSpreadColorRed(FromIndex As Integer, ToIndex As Integer, StartRed As Integer, EndRed As Integer)
Dim Ic As Single, Lc As Single
Dim Index As Integer, Num As Integer
Index = FromIndex
Num = ToIndex - FromIndex
If Num = 0 Then Num = 1
Ic = (EndRed - StartRed) / Num
Lc = StartRed

For Index = FromIndex To ToIndex
    If Index = ToIndex Then Lc = EndRed
    TextEX(Index).Color.Red = Lc
    Lc = Lc + Ic
Next Index

End Sub

Public Sub QMSpreadColorGreen(FromIndex As Integer, ToIndex As Integer, StartGreen As Integer, EndGreen As Integer)
Dim Ic As Single, Lc As Single
Dim Index As Integer, Num As Integer
Index = FromIndex
Num = ToIndex - FromIndex
If Num = 0 Then Num = 1
Ic = (EndGreen - StartGreen) / Num
Lc = StartGreen

For Index = FromIndex To ToIndex
    If Index = ToIndex Then Lc = EndGreen
    TextEX(Index).Color.Green = Lc
    Lc = Lc + Ic
Next Index

End Sub

Public Sub QMSpreadColorBlue(FromIndex As Integer, ToIndex As Integer, StartBlue As Integer, EndBlue As Integer)
Dim Ic As Single, Lc As Single
Dim Index As Integer, Num As Integer
Index = FromIndex
Num = ToIndex - FromIndex
If Num = 0 Then Num = 1
Ic = (EndBlue - StartBlue) / Num
Lc = StartBlue

For Index = FromIndex To ToIndex
    If Index = ToIndex Then Lc = EndBlue
    TextEX(Index).Color.Blue = Lc
    Lc = Lc + Ic
Next Index

End Sub

Public Sub QMSpreadAlpha(FromIndex As Integer, ToIndex As Integer, StartAlpha As Integer, EndAlpha As Integer)
Dim Ic As Single, Lc As Single
Dim Index As Integer, Num As Integer
Index = FromIndex
Num = ToIndex - FromIndex
If Num = 0 Then Num = 1
Ic = (EndAlpha - StartAlpha) / Num
Lc = StartAlpha

For Index = FromIndex To ToIndex
    If Index = ToIndex Then Lc = EndAlpha
    TextEX(Index).Color.Alpha = Lc
    Lc = Lc + Ic
Next Index

End Sub

Private Sub Class_Initialize()
    ReDim TextEX(0) As TextInfo
End Sub

Private Sub Class_Terminate()
    ReDim TextEX(0) As TextInfo
End Sub
