VERSION 5.00
Begin VB.Form Main 
   Caption         =   "Tutorial - A - Mouse Techniques"
   ClientHeight    =   7200
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   9600
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   480
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Engine As New DBTurbo2DEngine
Private Sub Form_Load()
Main.Show
DoEvents

Set Engine = New DBTurbo2DEngine

'set up display
Engine.InitializeDisplay Main.hWnd, False, 640, 480

'set up map view
Engine.SetUpMapView 0, 0, 640, 480, 1

'Set FPS
Engine.DBFPS.SetFrameRate 60

'Set Max Level
Engine.SetMaxLevel 1

'Initialize textures
With Engine.DBTexture
    .SetFolder App.Path + "/"
    .Add 64, "Button.png", , 4
    .Add 32, "Cursor.png", , 4
End With

'variable for loop
Dim I As Integer

'Initialize Overlays
With Engine.DBOverlay
    .QMSetOverlayView 0, 0, 320, 480
        .Add
        .SetTextureReference 1, 1
        .QMSetPutRectangle 1, 0, 0, 64, 32
        .QMSetGetRectangle 1, 0, 0, 64, 32
        .QMCenterOverlayX 1
    For I = 2 To 10
        .AddFromSource 1
    Next I
        .QMSpreadVertical 1, 10, 8
        .QMSpreadColorRed 1, 10, 0, 255
End With

'Initialize Sprite
With Engine.DBSprite
    For I = 1 To 5
        .Add
        .SetTextureReference I, 1
        .QMSetGetRectangle I, 0, 32, 64, 32
    Next I
    .QMSetPutRectangle 1, 0, 0, 64, 32
    .SetXPosition 1, 0
    .SetYPosition 1, 0
    .QMSetPutRectangle 2, -64, 0, 64, 32
    .SetXPosition 2, 640
    .SetYPosition 2, 0
    .QMSetPutRectangle 3, 0, -32, 64, 32
    .SetXPosition 3, 0
    .SetYPosition 3, 480
    .QMSetPutRectangle 4, -64, -32, 64, 32
    .SetXPosition 4, 640
    .SetYPosition 4, 480
    .QMSetPutRectangle 5, -32, -16, 64, 32
    .QMSetScale 5, 16
    .SetXPosition 5, 320
    .SetYPosition 5, 240
    .SetRotationAngle 5, 45
    .RenderNewStyle 5
    .Add
    .SetTextureReference 6, 2
    .QMSetPutRectangle 6, -7, -2, 32, 32
    .QMSetGetRectangle 6, 0, 0, 32, 32
    .SetZOrder 6, 1
End With

'initialize Text
With Engine.DBText
    .CreateFontMultiple 1, "timenewroman", 16
    .QMSetTextView 320, 0, 320, 480
    For I = 1 To 10
        .Add
        .SetFontIndex I, 1
        .SetVisible I, True
        .SetText I, "Text"
        .QMSetPutRectangle I, 0, 0, 37, 23
        .QMCenterTextX I
    Next I
    .QMSpreadVertical 1, 10, 8
End With

'Initialize KeyBoard
With Engine.DBKeyInput
    .Initialize Main.hWnd
    For I = 1 To 211
        .Add I
    Next I
End With

'Initialize Mouse
With Engine.DBMouse
    .InitializeMouse Main.hWnd
    .SetUpMouseViewRect 0, 0, 640, 480
    .AttachSpriteToCursor 6
    .SetMouseSpeed 1
End With

'Variable for loop
Dim BRunning As Boolean
BRunning = True

'Variable for sprite 5
Dim Angle As Single

Do While BRunning = True
'Check KeyBoard
If Engine.DBKeyInput.ReturnKeyDown(DIK_ESCAPE) = True Then BRunning = False

'do overlays
For I = 1 To 10
    'reset first
    Engine.DBOverlay.QMSetSpecular I, 0, 0, 0
    Engine.DBOverlay.QMSetScale I, 0
    'check mouse hover
    If Engine.DBMath.MouseHoverOverlayA(I) = True Then
        Engine.DBOverlay.QMSetSpecular I, 50, 50, 50
        Engine.DBOverlay.QMSetScale I, 5
    End If
Next I

'do sprites
For I = 1 To 4
    'reset first
    Engine.DBSprite.QMSetSpecular I, 0, 0, 0
    Engine.DBSprite.QMSetScale I, 0
    'check mouse hover
    If Engine.DBMath.MouseHoverSpriteA(I) = True Then
        Engine.DBSprite.QMSetSpecular I, 50, 50, 50
        Engine.DBSprite.QMSetScale I, 5
    End If
Next I

'do odd sprite
If Engine.DBMath.MouseHoverSpriteB(5) = False Then
    Engine.DBSprite.SetRotationAngle 5, Angle
    Angle = Angle + 1
    If Angle > 359 Then Angle = 0
End If

If Engine.DBMath.MouseHoverSpriteB(5) = True And Engine.DBMouse.GetLeftButton = True Then BRunning = False

'do Text
For I = 1 To 10
    'reset
    Engine.DBText.QMSetColor I, 255, 255, 255, 255
    If Engine.DBMath.MouseHoverText(I) = True Then
        Engine.DBText.QMSetColor I, 255, 0, 150, 150
    End If
Next I

'render
Engine.Render

Loop

Set Engine = Nothing
End

End Sub
