VERSION 5.00
Begin VB.Form Main 
   Caption         =   "Tutorial B - Counters"
   ClientHeight    =   7200
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   9600
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   480
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Engine As New DBTurbo2DEngine
Private Sub Form_Load()
Main.Show
DoEvents

Set Engine = New DBTurbo2DEngine

'set up display
Engine.InitializeDisplay Main.hWnd, False, 640, 480

'Set FPS
Engine.DBFPS.SetFrameRate 60

'set up map view
Engine.SetUpMapView 0, 0, 640, 480, 0

'Set Max Level
Engine.SetMaxLevel 1

'Initialize textures
With Engine.DBTexture
    .SetColorKeyBlue 255
    .SetFolder App.Path + "/"
    .Add 64, "Button.png", , 4
End With

'variable for loop
Dim I As Integer

'Initialize Sprite
With Engine.DBSprite
    For I = 1 To 4
        .Add
        .SetTextureReference I, 1
        .QMSetGetRectangle I, 0, 32, 64, 32
        .QMSetPutRectangle I, -32, -16, 64, 32
        .SetYPosition I, 240
        .QMSetScale I, 16
        .RenderNewStyle I
    Next I
    .RenderOldStyle 4
    .SetXPosition 1, 128
    .SetXPosition 2, 256
    .SetXPosition 3, 384
    .SetXPosition 4, 512
End With

'Initialize Counters
With Engine.DBCounter
    For I = 1 To 6
        .Add
    Next I
    .QMSetUpCounter1Loop 1, 0, 359, 1, 1, 1, True
    .QMSetUpCounter2Loop 2, -45, 45, 44, -44, 1, 1, 1, 1, 1, True
    .QMSetUpCounter2Loop 3, 0, 255, 250, 5, 5, 5, 1, 1, 1, True
    .QMSetUpCounter1Loop 4, 0, 255, 5, 1, 1, False
    .QMSetUpCounter1Loop 5, 0, 255, 5, 1, 1, False
    .QMSetUpCounter1Loop 6, 0, 255, 5, 1, 1, False
    
    .ResetCounter 1
    .ResetCounter 2
    .ResetCounter 3
    .ResetCounter 4
    .ResetCounter 5
    .ResetCounter 6
End With

'Initialize KeyBoard
With Engine.DBKeyInput
    .Initialize Main.hWnd
    For I = 1 To 211
        .Add I
    Next I
End With

'Variable for loop
Dim BRunning As Boolean
BRunning = True

Do While BRunning = True
'Check KeyBoard
If Engine.DBKeyInput.ReturnKeyDown(DIK_ESCAPE) = True Then BRunning = False

'sprite 1
Engine.DBSprite.SetRotationAngle 1, Engine.DBCounter.ReturnPositiveSingle(1)

'sprite 2
Engine.DBSprite.SetRotationAngle 2, Engine.DBCounter.ReturnPositiveSingle(2)

'sprite 3
Engine.DBSprite.QMSetAlpha 3, Engine.DBCounter.ReturnPositiveInteger(3)
Engine.DBSprite.QMSetScale 3, Engine.DBCounter.ReturnDivision(3, 10)

'sprite 4
Engine.DBSprite.QMSetSRed 4, Engine.DBCounter.ReturnPositiveInteger(4)
Engine.DBSprite.QMSetSGreen 4, Engine.DBCounter.ReturnPositiveInteger(5)
Engine.DBSprite.QMSetSBlue 4, Engine.DBCounter.ReturnPositiveInteger(6)

'render
Engine.Render

'check counter 4 to 6 for done and reset them
For I = 4 To 6
If Engine.DBCounter.ReturnCounterDone(I) = True Then
    Engine.DBCounter.SetMin1 I, Engine.DBCounter.GetMax1(I)
    Engine.DBCounter.SetMax1 I, Int(Engine.DBMath.GetRandomNumber(52, 0)) * 5
    Engine.DBCounter.ResetCounter I
End If
Next I

Loop

Set Engine = Nothing
End

End Sub

